'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getDeps;

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _pkgError = require('./pkg-error');

var _pkgError2 = _interopRequireDefault(_pkgError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getDeps(file) {
  const deps = [];
  // require\(\W+([\w-.]+)[\/\w]*[\W]+\)
  const reg = /require\(['"]+([a-zA-z][\w-.]+)[\/\w]*['"]+\)/i; // eslint-disable-line no-useless-escape

  const rl = _readline2.default.createInterface({
    input: _fs2.default.createReadStream(file)
  });

  return new Promise((resolve, reject) => {
    rl.on('line', line => {
      const matches = line.match(reg);
      if (matches) {
        deps.push(matches[1]);
      }
    }).on('close', () => {
      if (deps.length === 0) {
        return reject(new _pkgError2.default('this file has no pkgs to install'));
      }
      return resolve(deps);
    });
  });
}