'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tasks = undefined;

var _listr = require('listr');

var _listr2 = _interopRequireDefault(_listr);

var _getDeps = require('./get-deps');

var _getDeps2 = _interopRequireDefault(_getDeps);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _filter = require('./filter');

var _filter2 = _interopRequireDefault(_filter);

var _exec = require('./exec');

var _exec2 = _interopRequireDefault(_exec);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const tasks = exports.tasks = _co2.default.wrap(function* (input, flags) {
  const tasks = new _listr2.default([{
    title: 'Anylise the dependent pkgs',
    task: () => Promise.resolve('done')
  }, {
    title: 'Filter the pkgs',
    skip: ctx => ctx.deps.length === 0,
    task: ctx => {
      ctx.deps = ctx.deps.filter(pkg => (0, _filter2.default)(pkg));
    }
  }, {
    title: 'Install pkgs via yarn',
    skip: ctx => {
      if (ctx.deps.length === 0) {
        return 'deps already exists';
      }
    },
    task: ctx => (0, _exec2.default)('yarn', ['add'].concat(ctx.deps, ctx.opts))
  }]);

  const opts = [];
  if (flags.d) {
    opts.push('--dev');
  }
  const deps = yield (0, _getDeps2.default)(input);
  return tasks.run({ deps, opts });
});